Index: code/trunk/src/orxonox/core/Iterator.h
===================================================================
--- code/trunk/src/orxonox/core/Iterator.h	(revision 265)
+++ code/trunk/src/orxonox/core/Iterator.h	(revision 790)
@@ -1,11 +1,64 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/*!
+    @file Iterator.h
+    @brief Definition and implementation of the Iterator class.
+
+    The Iterator of a given class allows to iterate through an ObjectList, containing all objects of that type.
+    This is the only way to access the objects stored in an ObjectList.
+
+    Usage:
+    for (Iterator<class> it = ObjectList<class>::start(); it != 0; ++it)
+    {
+        it->someFunction(...);
+        class* myObject = *it;
+    }
+
+    Warning: Don't delete objects directly through the iterator.
+*/
+
 #ifndef _Iterator_H__
 #define _Iterator_H__
 
+#include "CorePrereqs.h"
+
+#include "ObjectList.h"
+#include "Debug.h"
+
 namespace orxonox
 {
+    //! The iterator allows to iterate through an ObjectList of a given class.
     template <class T>
     class Iterator
     {
         public:
+            /**
+                @brief Constructor: Sets the element, whereon the iterator points, to zero.
+            */
             Iterator()
             {
@@ -13,4 +66,8 @@
             }
 
+            /**
+                @brief Constructor: Sets the element, whereon the iterator points, to a given element.
+                @param element The element to start with
+            */
             Iterator(ObjectListElement<T>* element)
             {
@@ -18,4 +75,8 @@
             }
 
+            /**
+                @brief Overloading of the ++it operator: Iterator points to the next object in the list.
+                @return The Iterator itself
+            */
             Iterator<T> operator++()
             {
@@ -24,4 +85,19 @@
             }
 
+            /**
+                @brief Overloading of the it++ operator: Iterator points to the next object in the list.
+                @return The Iterator itself
+            */
+            Iterator<T> operator++(int i)
+            {
+                Iterator<T> copy = *this;
+                this->element_ = this->element_->next_;
+                return copy;
+            }
+
+            /**
+                @brief Overloading of the --it operator: Iterator points to the previous object in the list.
+                @return The Iterator itself
+            */
             Iterator<T> operator--()
             {
@@ -30,4 +106,19 @@
             }
 
+            /**
+                @brief Overloading of the it-- operator: Iterator points to the previous object in the list.
+                @return The Iterator itself
+            */
+            Iterator<T> operator--(int i)
+            {
+                Iterator<T> copy = *this;
+                this->element_ = this->element_->prev_;
+                return copy;
+            }
+
+            /**
+                @brief Overloading of the *it operator: returns the pointer to the object.
+                @return The object the Iterator points at
+            */
             T* operator*()
             {
@@ -35,4 +126,8 @@
             }
 
+            /**
+                @brief Overloading of the it-> operator: returns the pointer to the object.
+                @return The object the Iterator points at
+            */
             T* operator->() const
             {
@@ -41,4 +136,8 @@
             }
 
+            /**
+                @brief Overloading of the typecast-operator to bool: returns true if the iterator points to an existing object.
+                @return True if the iterator points to an existing object.
+            */
             operator bool()
             {
@@ -46,8 +145,14 @@
             }
 
+            /**
+                @brief Overloading of the (it != int) operator: Used for (it != 0) instead of typecast-operator to bool.
+                @param compare The integer (must be zero, everything else makes no sense).
+                @return True if the iterator points to an existing object.
+            */
             bool operator!=(int compare)
             {
+                // Comparing with anything except zero makes no sense
                 if (compare != 0)
-                    std::cout << "Warning: Comparing the " << ClassIdentifier<T>::getIdentifier()->getName() << "-List-Iterator with " << compare << " has no effect. Only comparison with 0 works.\n";
+                    COUT(2) << "Warning: Comparing the " << ClassIdentifier<T>::getIdentifier()->getName() << "-List-Iterator with " << compare << " has no effect. Only comparison with 0 works." << std::endl;
 
                 return (this->element_ != 0);
@@ -55,7 +160,7 @@
 
         private:
-            ObjectListElement<T>* element_;
+            ObjectListElement<T>* element_;     //!< The element the Iterator points at
     };
 }
 
-#endif
+#endif /* _Iterator_H__ */
Index: code/trunk/src/orxonox/core/Language.cc
===================================================================
--- code/trunk/src/orxonox/core/Language.cc	(revision 790)
+++ code/trunk/src/orxonox/core/Language.cc	(revision 790)
@@ -0,0 +1,336 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/*!
+    @file Language.cc
+    @brief Implementation of the Language and the LanguageEntry class.
+*/
+
+#include <fstream>
+
+#include "CoreIncludes.h"
+#include "Language.h"
+
+namespace orxonox
+{
+    // ###############################
+    // ###      LanguageEntry      ###
+    // ###############################
+    /**
+        @brief Constructor: Sets the default entry.
+        @param fallbackEntry The default entry
+    */
+    LanguageEntry::LanguageEntry(const std::string& fallbackEntry)
+    {
+        RegisterRootObject(LanguageEntry);
+
+        this->fallbackEntry_ = fallbackEntry;
+        this->translatedEntry_ = fallbackEntry; // Set the translation to the fallback entry, for the case that no translation gets assigned
+        this->bTranslationSet_ = false;
+    }
+
+    /**
+        @brief Sets the translation of the entry.
+        @param translation The translation
+    */
+    void LanguageEntry::setTranslation(const std::string& translation)
+    {
+        // Check if the translation is more than just an empty string
+        if (translation.compare("") != 0)
+        {
+            this->translatedEntry_ = translation;
+            this->bTranslationSet_ = true;
+        }
+        else
+            this->translatedEntry_ = this->fallbackEntry_;
+    }
+
+    /**
+        @brief Sets the default entry.
+        @param fallbackEntry The default entry
+    */
+    void LanguageEntry::setDefault(const std::string& fallbackEntry)
+    {
+        // If the default entry changes and the translation wasn't set yet, use the new default entry as translation
+        if (!this->bTranslationSet_)
+            this->translatedEntry_ = fallbackEntry;
+
+        this->fallbackEntry_ = fallbackEntry;
+    }
+
+    // ###############################
+    // ###        Language         ###
+    // ###############################
+    /**
+        @brief Constructor: Reads the default language file and sets some values.
+    */
+    Language::Language()
+    {
+        RegisterRootObject(Language);
+
+        this->defaultLanguage_ = "default";
+        this->defaultTranslation_ = "ERROR: LANGUAGE ENTRY DOESN'T EXIST!";
+
+        // Read the default language file to create all known LanguageEntry objects
+        this->readDefaultLanguageFile();
+    }
+
+    /**
+        @brief Function to collect the SetConfigValue-macro calls.
+    */
+    void Language::setConfigValues()
+    {
+        SetConfigValue(language_, this->defaultLanguage_).description("The language of the ingame text");
+
+        // Read the translation file after the language was configured
+        this->readTranslatedLanguageFile();
+    }
+
+    /**
+        @brief Returns a reference to the only existing instance of the Language class and calls the setConfigValues() function.
+        @return The reference to the only existing instance
+    */
+    Language& Language::getLanguage()
+    {
+        // Use static variables to avoid conflicts while executing this code before main()
+        static Language theOnlyLanguageObject = Language();
+        static bool bCreatingTheOnlyLanguageObject = true;
+
+        // This workaround is used to set a description of the own config value without creating an infinite recursion
+        if (bCreatingTheOnlyLanguageObject)
+        {
+            bCreatingTheOnlyLanguageObject = false;
+            theOnlyLanguageObject.setConfigValues();
+        }
+
+        return theOnlyLanguageObject;
+    }
+
+    /**
+        @brief Creates a new LanguageEntry with a given name and a given default entry.
+        @param name The name of the entry
+        @param entry The default entry
+        @return The created LanguageEntry object
+    */
+    LanguageEntry* Language::createEntry(const LanguageEntryName& name, const std::string& entry)
+    {
+        std::map<std::string, LanguageEntry*>::const_iterator it = this->languageEntries_.find(name);
+
+        // Make sure we don't create a duplicate entry
+        if (it == this->languageEntries_.end())
+        {
+            LanguageEntry* newEntry = new LanguageEntry(entry);
+            newEntry->setName(name);
+            this->languageEntries_[name] = newEntry;
+            return newEntry;
+        }
+
+        COUT(2) << "Warning: Language entry " << name << " is duplicate in " << getFileName(this->defaultLanguage_) << "!" << std::endl;
+        return it->second;
+    }
+
+    /**
+        @brief Adds a new LanguageEntry, if it's not already existing.
+        @param name The name of the entry
+        @param entry The default entry
+    */
+    void Language::addEntry(const LanguageEntryName& name, const std::string& entry)
+    {
+        COUT(5) << "Called addEntry with\n  name: " << name << "\n  entry: " <<  entry << std::endl;
+        std::map<std::string, LanguageEntry*>::const_iterator it = this->languageEntries_.find(name);
+        if (it == this->languageEntries_.end())
+        {
+            // The entry isn't available yet, meaning it's new, so create it
+            this->createEntry(name, entry);
+        }
+        else if (it->second->getDefault().compare(entry) == 0)
+        {
+            // The entry is available and the default string is the same, so return because everything is fine
+            return;
+        }
+        else
+        {
+            // The defined default entry is not the same as in the default language file - change it to the new entry
+            it->second->setDefault(entry);
+        }
+
+        // Write the default language file because either a new entry was created or an existing entry has changed
+        this->writeDefaultLanguageFile();
+
+    }
+
+    /**
+        @brief Returns the translation of a given entry.
+        @param name The name of the entry
+        @return The translation
+    */
+    const std::string& Language::getTranslation(const LanguageEntryName& name) const
+    {
+        std::map<std::string, LanguageEntry*>::const_iterator it = this->languageEntries_.find(name);
+        if (it != this->languageEntries_.end())
+            return it->second->getTranslation();
+        else
+        {
+            // Uh, oh, an undefined entry was requested: return the default string
+            COUT(2) << "Error: Language entry \"" << name << "\" not found!" << std::endl;
+            return this->defaultTranslation_;
+        }
+    }
+
+    /**
+        @brief Creates the name of the language file out of the languages name.
+        @param language The name of the language
+        @return The filename
+    */
+    const std::string Language::getFileName(const std::string& language)
+    {
+        return std::string("translation_" + language + ".lang");
+    }
+
+    /**
+        @brief Reads the default language file and creates a LanguageEntry objects for every entry.
+    */
+    void Language::readDefaultLanguageFile()
+    {
+        COUT(4) << "Read default language file." << std::endl;
+
+        // This creates the file if it's not existing
+        std::ofstream createFile;
+        createFile.open(getFileName(this->defaultLanguage_).c_str(), std::fstream::app);
+        createFile.close();
+
+        // Open the file
+        std::ifstream file;
+        file.open(getFileName(this->defaultLanguage_).c_str(), std::fstream::in);
+
+        if (!file.is_open())
+        {
+            COUT(1) << "Error: Couldn't open file " << getFileName(this->defaultLanguage_) << " to read the default language entries!" << std::endl;
+            return;
+        }
+
+        char line[1024];
+
+        // Iterate through the file and create the LanguageEntries
+        while (file.good() && !file.eof())
+        {
+            file.getline(line, 1024);
+            std::string lineString = std::string(line);
+
+            // Check if the line is empty
+            if (lineString.compare("") != 0)
+            {
+                unsigned int pos = lineString.find('=');
+
+                // Check if the length is at least 3 and if there's an entry before and behind the =
+                if (pos > 0 && pos < (lineString.size() - 1) && lineString.size() >= 3)
+                    this->createEntry(lineString.substr(0, pos), lineString.substr(pos + 1));
+                else
+                    COUT(2) << "Warning: Invalid language entry \"" << lineString << "\" in " << getFileName(this->defaultLanguage_) << std::endl;
+            }
+        }
+
+        file.close();
+    }
+
+    /**
+        @brief Reads the language file of the configured language and assigns the translations to the corresponding LanguageEntry object.
+    */
+    void Language::readTranslatedLanguageFile()
+    {
+        COUT(4) << "Read translated language file (" << this->language_ << ")." << std::endl;
+
+        // Open the file
+        std::ifstream file;
+        file.open(getFileName(this->language_).c_str(), std::fstream::in);
+
+        if (!file.is_open())
+        {
+            COUT(1) << "Error: Couldn't open file " << getFileName(this->language_) << " to read the translated language entries!" << std::endl;
+            ResetConfigValue(language_);
+            COUT(3) << "Info: Reset language to " << this->defaultLanguage_ << "." << std::endl;
+            return;
+        }
+
+        char line[1024];
+
+        // Iterate through the file and create the LanguageEntries
+        while (file.good() && !file.eof())
+        {
+            file.getline(line, 1024);
+            std::string lineString = std::string(line);
+
+            // Check if the line is empty
+            if (lineString.compare("") != 0)
+            {
+                unsigned int pos = lineString.find('=');
+
+                // Check if the length is at least 3 and if there's an entry before and behind the =
+                if (pos > 0 && pos < (lineString.size() - 1) && lineString.size() >= 3)
+                {
+                    std::map<std::string, LanguageEntry*>::const_iterator it = this->languageEntries_.find(lineString.substr(0, pos));
+
+                    // Check if the entry exists
+                    if (it != this->languageEntries_.end())
+                        it->second->setTranslation(lineString.substr(pos + 1));
+                    else
+                        this->createEntry(lineString.substr(0, pos), this->defaultTranslation_)->setTranslation(lineString.substr(pos + 1));
+                }
+                else
+                    COUT(2) << "Warning: Invalid language entry \"" << lineString << "\" in " << getFileName(this->language_) << std::endl;
+            }
+        }
+
+        file.close();
+    }
+
+    /**
+        @brief Writes all default entries to the default language file.
+    */
+    void Language::writeDefaultLanguageFile() const
+    {
+        COUT(4) << "Write default language file." << std::endl;
+
+        // Open the file
+        std::ofstream file;
+        file.open(getFileName(this->defaultLanguage_).c_str(), std::fstream::out);
+
+        if (!file.is_open())
+        {
+            COUT(1) << "Error: Couldn't open file " << getFileName(this->defaultLanguage_) << " to write the default language entries!" << std::endl;
+            return;
+        }
+
+        // Iterate through the list an write the lines into the file
+        for (Iterator<LanguageEntry> it = ObjectList<LanguageEntry>::start(); it; ++it)
+        {
+            file << it->getName() << "=" << it->getDefault() << std::endl;
+        }
+
+        file.close();
+    }
+}
Index: code/trunk/src/orxonox/core/Language.h
===================================================================
--- code/trunk/src/orxonox/core/Language.h	(revision 790)
+++ code/trunk/src/orxonox/core/Language.h	(revision 790)
@@ -0,0 +1,119 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/*!
+    @file Language.h
+    @brief Definition of the Language and the LanguageEntry class.
+
+    The Language class is used, to get a translation of a string in the configured language.
+    The string is identified by another string, the name of the entry.
+    If the translation in the configured language isn't available, the default entry, defined in the code, is used.
+
+    Usage:
+     - Set the entry with the default string:
+       Language::getLanguage()->addEntry("name of the entry", "the string to translate");
+
+     - Get the translation of the entry in the configured language:
+       std::cout << Language::getLanguage()->getTranslation("name of the entry") << std::endl;
+*/
+
+#ifndef _Language_H__
+#define _Language_H__
+
+#include <map>
+#include <string>
+
+#include "CorePrereqs.h"
+#include "OrxonoxClass.h"
+
+namespace orxonox
+{
+    typedef std::string LanguageEntryName;
+
+    //! The LanguageEntry class stores the default- and the translated string of a given entry in the language file.
+    class _CoreExport LanguageEntry : public OrxonoxClass
+    {
+        public:
+            explicit LanguageEntry(const std::string& fallbackEntry);
+            void setTranslation(const std::string& translation);
+            void setDefault(const std::string& fallbackEntry);
+
+            /**
+              @brief Returns the translated entry in the configured language.
+              @return The translated entry
+            */
+            inline const std::string& getTranslation()
+                { return this->translatedEntry_; }
+
+            /**
+              @brief Returns the default entry.
+              @return The default entry
+            */
+            inline const std::string& getDefault()
+                { return this->fallbackEntry_; }
+
+        private:
+            std::string fallbackEntry_;                             //!< The default entry: Used, if no translation is available or no language configured
+            std::string translatedEntry_;                           //!< The translated entry in the configured language
+            bool bTranslationSet_;                                  //!< True if the translation was set
+    };
+    template class _CoreExport orxonox::ClassIdentifier<LanguageEntry>;
+    template class _CoreExport orxonox::ObjectList<LanguageEntry>;
+
+    //! The Language class manges the language files and entries and stores the LanguageEntry objects in a map.
+    class _CoreExport Language : public OrxonoxClass
+    {
+        template <class T>
+        friend class ClassIdentifier; // forward declaration because of the private destructor
+
+        public:
+            static Language& getLanguage();
+            void setConfigValues();
+            void addEntry(const LanguageEntryName& name, const std::string& entry);
+            const std::string& getTranslation(const LanguageEntryName& name) const;
+
+        private:
+            Language();
+            Language(const Language& language) {}   // don't copy
+            virtual ~Language() {};                 // don't delete
+
+            void readDefaultLanguageFile();
+            void readTranslatedLanguageFile();
+            void writeDefaultLanguageFile() const;
+            static const std::string getFileName(const std::string& language);
+            LanguageEntry* createEntry(const LanguageEntryName& name, const std::string& entry);
+
+            std::string language_;                                  //!< The configured language
+            std::string defaultLanguage_;                           //!< The default language
+            std::string defaultTranslation_;                        //!< The returned string, if an entry unavailable entry is requested
+            std::map<std::string, LanguageEntry*> languageEntries_; //!< A map to store all LanguageEntry objects and their name
+    };
+    template class _CoreExport orxonox::ClassIdentifier<Language>;
+    template class _CoreExport orxonox::ObjectList<Language>;
+}
+
+#endif /* _Language_H__ */
Index: code/trunk/src/orxonox/core/MetaObjectList.cc
===================================================================
--- code/trunk/src/orxonox/core/MetaObjectList.cc	(revision 265)
+++ code/trunk/src/orxonox/core/MetaObjectList.cc	(revision 790)
@@ -1,6 +1,41 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/*!
+    @file MetaObjectList.cc
+    @brief Implementation of the MetaObjectList class.
+*/
+
 #include "MetaObjectList.h"
 
 namespace orxonox
 {
+    /**
+        @brief Constructor: Sets first_ to zero.
+    */
     MetaObjectList::MetaObjectList()
     {
@@ -8,4 +43,7 @@
     }
 
+    /**
+        @brief Destructor: Removes all elements from the list, causing them to remove the stored ObjectListElement from the ObjectList.
+    */
     MetaObjectList::~MetaObjectList()
     {
Index: code/trunk/src/orxonox/core/MetaObjectList.h
===================================================================
--- code/trunk/src/orxonox/core/MetaObjectList.h	(revision 265)
+++ code/trunk/src/orxonox/core/MetaObjectList.h	(revision 790)
@@ -1,16 +1,57 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/*!
+    @file MetaObjectList.h
+    @brief Definition of the MetaObjectList class.
+
+    The MetaObjectList is a single-linked list, containing all list-elements and their
+    lists wherein the object, owning the MetaObjectList, is registered.
+    This allows much faster deletion of objects because no iteration is needed.
+*/
+
 #ifndef _MetaObjectList_H__
 #define _MetaObjectList_H__
 
+#include "CorePrereqs.h"
+
 #include "ObjectList.h"
 #include "Identifier.h"
+#include "Debug.h"
 
 namespace orxonox
 {
+    //! Base-class of MetaObjectListElement, because those is a template
     class BaseMetaObjectListElement
     {
         public:
+            /** @brief Default destructor */
             virtual ~BaseMetaObjectListElement() {};
 
-            BaseMetaObjectListElement* next_;
+            BaseMetaObjectListElement* next_;       //!< The next Element in the list
     };
 
@@ -18,4 +59,5 @@
     // ###  MetaObjectListElement  ###
     // ###############################
+    //! The list-element of the MetaObjectList
     template <class T>
     class MetaObjectListElement : public BaseMetaObjectListElement
@@ -23,10 +65,13 @@
         public:
             MetaObjectListElement(ObjectList<T>* list, ObjectListElement<T>* element);
-            ~MetaObjectListElement();
+            virtual ~MetaObjectListElement();
 
-            ObjectListElement<T>* element_;
-            ObjectList<T>* list_;
+            ObjectListElement<T>* element_;         //!< The list element, containing the object
+            ObjectList<T>* list_;                   //!< The list, containing the element
     };
 
+    /**
+        @brief Constructor: Creates the list-element with given list and element.
+    */
     template <class T>
     MetaObjectListElement<T>::MetaObjectListElement(ObjectList<T>* list, ObjectListElement<T>* element)
@@ -37,4 +82,7 @@
     }
 
+    /**
+        @brief Destructor: Removes the ObjectListElement from the ObjectList by linking next_ and prev_ of the ObjectListElement.
+    */
     template <class T>
     MetaObjectListElement<T>::~MetaObjectListElement()
@@ -43,15 +91,13 @@
             this->element_->next_->prev_ = this->element_->prev_;
         else
-            this->list_->last_ = this->element_->prev_;
+            this->list_->last_ = this->element_->prev_; // If there is no next_, we deleted the last object and have to update the last_ pointer of the list
 
         if (this->element_->prev_)
             this->element_->prev_->next_ = this->element_->next_;
         else
-            this->list_->first_ = this->element_->next_;
+            this->list_->first_ = this->element_->next_; // If there is no prev_, we deleted the first object and have to update the first_ pointer of the list
 
 
-#if HIERARCHY_VERBOSE
-        std::cout << "*** Removing Object from " << ClassIdentifier<T>::getIdentifier()->getName() << "-list.\n";
-#endif
+        COUT(4) << "*** Removing Object from " << ClassIdentifier<T>::getIdentifier()->getName() << "-list." << std::endl;
         delete this->element_;
     }
@@ -61,4 +107,10 @@
     // ###       ObjectList        ###
     // ###############################
+    //!  The MetaObjectList contains ObjectListElements and their ObjectLists.
+    /**
+        The MetaObjectList is a single-linked list, containing all list-elements and their
+        lists wherein the object that owns the MetaObjectList is registered.
+        This allows much faster deletion of objects because no iteration is needed.
+    */
     class MetaObjectList
     {
@@ -69,7 +121,12 @@
             void add(ObjectList<T>* list, ObjectListElement<T>* element);
 
-            BaseMetaObjectListElement* first_;
+            BaseMetaObjectListElement* first_;      //!< The first element in the list
     };
 
+    /**
+        @brief Adds an ObjectList and an element of that list to the MetaObjectList.
+        @param list The ObjectList wherein the element is
+        @param element The element wherein the object is
+    */
     template <class T>
     void MetaObjectList::add(ObjectList<T>* list, ObjectListElement<T>* element)
@@ -81,3 +138,3 @@
 }
 
-#endif
+#endif /* _MetaObjectList_H__ */
